module Ta : sig
  val id : 'a -> 'a
  type 'a equal = {equal : 'a -> 'a -> bool}
  val equal : 'a equal -> 'a -> 'a -> bool
  val eq : 'a equal -> 'a -> 'a -> bool
  type color = R | B
  type ('a, 'b) rbta = Empty |
    Branch of color * ('a, 'b) rbta * 'a * 'b * ('a, 'b) rbta
  type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool}
  val less_eq : 'a ord -> 'a -> 'a -> bool
  val less : 'a ord -> 'a -> 'a -> bool
  type 'a preorder = {ord_preorder : 'a ord}
  type 'a order = {preorder_order : 'a preorder}
  type 'a linorder = {order_linorder : 'a order}
  type ('a, 'b) rbt = Rbt of ('a, 'b) rbta
  type ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list
  val lhs : ('a, 'b) ta_rule -> 'a
  val hd : 'a list -> 'a
  val tl : 'a list -> 'a list
  val suc : Big_int.big_int -> Big_int.big_int
  val rhsl : ('a, 'b) ta_rule -> 'b
  val rhsq : ('a, 'b) ta_rule -> 'a list
  type ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b
  val comp : ('a -> 'b) -> ('c -> 'a) -> 'c -> 'b
  val map : ('a -> 'b) -> 'a list -> 'b list
  val fold : ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b
  val rev : 'a list -> 'a list
  val zip : 'a list -> 'b list -> ('a * 'b) list
  type 'a tree = Node of 'a * 'a tree list
  val null : 'a list -> bool
  type 'a itself = Type
  val empty : 'a linorder -> ('a, 'b) rbt
  val r_prod : ('a, 'b) ta_rule -> ('c, 'd) ta_rule -> (('a * 'c), 'b) ta_rule
  type 'a dlist = Dlist of 'a list
  val foldl : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a
  val map_of : 'a equal -> ('a * 'b) list -> 'a -> 'b option
  val ord_nat : Big_int.big_int ord
  val the : 'a option -> 'a
  val impl_of : 'a linorder -> ('a, 'b) rbt -> ('a, 'b) rbta
  val balance : ('a, 'b) rbta -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val ins :
    'a linorder ->
      ('a -> 'b -> 'b -> 'b) -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val paint : color -> ('a, 'b) rbta -> ('a, 'b) rbta
  val insert_with_key :
    'a linorder ->
      ('a -> 'b -> 'b -> 'b) -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val insertc : 'a linorder -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val insert : 'a linorder -> 'a -> 'b -> ('a, 'b) rbt -> ('a, 'b) rbt
  val lookupa : 'a linorder -> ('a, 'b) rbta -> 'a -> 'b option
  val lookup : 'a linorder -> ('a, 'b) rbt -> 'a -> 'b option
  val inj_image_filter_cp :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
      (('d -> 'b -> 'b) -> 'e -> 'b -> 'b) ->
        'b -> ('f -> 'b -> 'b) ->
                ('a -> 'd -> 'f) -> ('a -> 'd -> bool) -> 'c -> 'e -> 'b
  val cart :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
      (('d -> 'b -> 'b) -> 'e -> 'b -> 'b) ->
        'b -> ('a * 'd -> 'b -> 'b) -> 'c -> 'e -> 'b
  val emptya : 'a dlist
  val member : 'a equal -> 'a list -> 'a -> bool
  val inserta : 'a equal -> 'a -> 'a list -> 'a list
  val list_of_dlist : 'a dlist -> 'a list
  val insertb : 'a equal -> 'a -> 'a dlist -> 'a dlist
  val membera : 'a equal -> 'a dlist -> 'a -> bool
  val remdups : 'a equal -> 'a list -> 'a list
  val it_add :
    ('a -> 'b -> 'c -> 'c) ->
      (('a -> 'b -> 'c -> 'c) -> 'c -> 'c -> 'c) -> 'c -> 'c -> 'c
  val equal_nat : Big_int.big_int equal
  val preorder_nat : Big_int.big_int preorder
  val order_nat : Big_int.big_int order
  val list_all : ('a -> bool) -> 'a list -> bool
  val is_none : 'a option -> bool
  val iti_sel :
    (('a option -> bool) ->
      ('b -> 'c -> 'd -> 'e option) -> 'f -> 'g option -> 'e option) ->
      'f -> ('b -> 'c -> 'e option) -> 'e option
  val map_sng : 'a -> ('b -> 'c -> 'a -> 'a) -> 'b -> 'c -> 'a
  val minus_nat : Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val it_size :
    (('a -> Big_int.big_int -> Big_int.big_int) ->
      'b -> Big_int.big_int -> Big_int.big_int) ->
      'b -> Big_int.big_int
  val remap_rule : ('a -> 'b) -> ('a, 'c) ta_rule -> ('b, 'c) ta_rule
  type 'a hashable =
    {hashcode : 'a -> Big_int.big_int;
      bounded_hashcode : Big_int.big_int -> 'a -> Big_int.big_int;
      def_hashmap_size : 'a itself -> Big_int.big_int}
  val hashcode : 'a hashable -> 'a -> Big_int.big_int
  val bounded_hashcode : 'a hashable -> Big_int.big_int -> 'a -> Big_int.big_int
  val def_hashmap_size : 'a hashable -> 'a itself -> Big_int.big_int
  val list_all_zip : ('a -> 'b -> bool) -> 'a list -> 'b list -> bool
  val ls_memb : 'a equal -> 'a -> 'a dlist -> bool
  type ('a, 'b) assoc_list = Assoc_List of ('a * 'b) list
  type ('a, 'b) hashmap = RBT_HM of (Big_int.big_int, ('a, 'b) assoc_list) rbt
  type ('a, 'b, 'c) hashedTa_ext =
    HashedTa_ext of
      ('a, unit) hashmap * ('a, 'b) ta_rule dlist *
        ('b, ('a, 'b) ta_rule dlist) hashmap option *
        ('a, ('a, 'b) ta_rule dlist) hashmap option *
        (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option * 'c
  val hta_idx_f :
    ('a, 'b, 'c) hashedTa_ext -> ('b, ('a, 'b) ta_rule dlist) hashmap option
  val linorder_nat : Big_int.big_int linorder
  val rm_lookup : 'a linorder -> 'a -> ('a, 'b) rbt -> 'b option
  val impl_ofa : ('a, 'b) assoc_list -> ('a * 'b) list
  val lookupb : 'a equal -> ('a, 'b) assoc_list -> 'a -> 'b option
  val lm_lookup : 'a equal -> 'a -> ('a, 'b) assoc_list -> 'b option
  val lookupc :
    'a equal * 'a hashable ->
      'a -> (Big_int.big_int, ('a, 'b) assoc_list) rbt -> 'b option
  val impl_of_RBT_HM :
    'a hashable ->
      ('a, 'b) hashmap -> (Big_int.big_int, ('a, 'b) assoc_list) rbt
  val hm_lookup : 'a equal * 'a hashable -> 'a -> ('a, 'b) hashmap -> 'b option
  val idx_lookup : ('a -> 'b -> 'c option) -> 'c -> 'a -> 'b -> 'c
  val ls_empty : 'a dlist
  val hl_idx_lookup :
    'a equal * 'a hashable -> 'a -> ('a, 'b dlist) hashmap -> 'b dlist
  val hta_lookup_f :
    'a equal * 'a hashable ->
      'a -> ('b, 'a, 'c) hashedTa_ext -> ('b, 'a) ta_rule dlist
  val ls_ins : 'a equal -> 'a -> 'a dlist -> 'a dlist
  val it_image_filter :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
      'b -> ('d -> 'b -> 'b) -> ('a -> 'd option) -> 'c -> 'b
  val iti_iteratea :
    (('a -> bool) -> ('b -> 'a -> 'a) -> 'c -> 'a -> 'a) ->
      ('b -> 'a -> 'a) -> 'c -> 'a -> 'a
  val iteratei_aux : ('a -> bool) -> ('b -> 'a -> 'a) -> 'b list -> 'a -> 'a
  val iteratei : ('a -> bool) -> ('b -> 'a -> 'a) -> 'b dlist -> 'a -> 'a
  val ls_iteratei : ('a -> bool) -> ('b -> 'a -> 'a) -> 'b dlist -> 'a -> 'a
  val ls_iterate : ('a -> 'b -> 'b) -> 'a dlist -> 'b -> 'b
  val ls_image_filter : 'b equal -> ('a -> 'b option) -> 'a dlist -> 'b dlist
  val faccs :
    'a equal -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> 'b tree -> 'a dlist
  val emptyb : ('a, 'b) assoc_list
  val lm_empty : ('a, 'b) assoc_list
  val fst : 'a * 'b -> 'a
  val snd : 'a * 'b -> 'b
  val update_with_aux :
    'b equal -> 'a -> 'b -> ('a -> 'a) -> ('b * 'a) list -> ('b * 'a) list
  val update_with :
    'a equal ->
      'b -> 'a -> ('b -> 'b) -> ('a, 'b) assoc_list -> ('a, 'b) assoc_list
  val update :
    'a equal -> 'a -> 'b -> ('a, 'b) assoc_list -> ('a, 'b) assoc_list
  val lm_update :
    'a equal -> 'a -> 'b -> ('a, 'b) assoc_list -> ('a, 'b) assoc_list
  val lm_sng : 'a equal -> 'a -> 'b -> ('a, 'b) assoc_list
  val rm_update : 'a linorder -> 'a -> 'b -> ('a, 'b) rbt -> ('a, 'b) rbt
  val updatea :
    'a equal * 'a hashable ->
      'a -> 'b -> (Big_int.big_int, ('a, 'b) assoc_list) rbt ->
                    (Big_int.big_int, ('a, 'b) assoc_list) rbt
  val hm_update :
    'a equal * 'a hashable -> 'a -> 'b -> ('a, 'b) hashmap -> ('a, 'b) hashmap
  val itoi_iterateo :
    (('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a) ->
      ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a
  val rm_iterateoi :
    ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbta -> 'a -> 'a
  val rm_iterateoia :
    'b linorder ->
      ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbt -> 'a -> 'a
  val rm_iterateo :
    'a linorder -> ('a -> 'b -> 'c -> 'c) -> ('a, 'b) rbt -> 'c -> 'c
  val rm_iterate :
    'a linorder -> ('a -> 'b -> 'c -> 'c) -> ('a, 'b) rbt -> 'c -> 'c
  val iti_iterate :
    (('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a) ->
      ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a
  val iteratei_auxa :
    ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b * 'c) list -> 'a -> 'a
  val iterateia :
    ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) assoc_list -> 'a -> 'a
  val lm_iteratei :
    ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) assoc_list -> 'a -> 'a
  val lm_iterate : ('a -> 'b -> 'c -> 'c) -> ('a, 'b) assoc_list -> 'c -> 'c
  val iterate :
    'd linorder ->
      ('a -> 'b -> 'c -> 'c) -> ('d, ('a, 'b) assoc_list) rbt -> 'c -> 'c
  val hm_iterate :
    'a hashable -> ('a -> 'b -> 'c -> 'c) -> ('a, 'b) hashmap -> 'c -> 'c
  val hm_add :
    'a equal * 'a hashable ->
      ('a, 'b) hashmap -> ('a, 'b) hashmap -> ('a, 'b) hashmap
  val rm_iteratei :
    'b linorder ->
      ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbt -> 'a -> 'a
  val rm_sel :
    'a linorder -> ('a, 'b) rbt -> ('a -> 'b -> 'c option) -> 'c option
  val lm_sel : ('a, 'b) assoc_list -> ('a -> 'b -> 'c option) -> 'c option
  val sel :
    'a hashable ->
      (Big_int.big_int, ('a, 'b) assoc_list) rbt ->
        ('a -> 'b -> 'c option) -> 'c option
  val hm_sel :
    'a hashable -> ('a, 'b) hashmap -> ('a -> 'b -> 'c option) -> 'c option
  val s_ins : ('a -> unit -> 'b -> 'c) -> 'a -> 'b -> 'c
  val hs_ins :
    'a equal * 'a hashable -> 'a -> ('a, unit) hashmap -> ('a, unit) hashmap
  val s_sel :
    ('a -> ('b -> unit -> 'c option) -> 'c option) ->
      'a -> ('b -> 'c option) -> 'c option
  val hs_sel :
    'a hashable -> ('a, unit) hashmap -> ('a -> 'b option) -> 'b option
  val equal_lista : 'a equal -> 'a list -> 'a list -> bool
  val equal_list : 'a equal -> ('a list) equal
  val size_list : 'a list -> Big_int.big_int
  val it_inter :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
      ('a -> 'd -> bool) -> 'b -> ('a -> 'b -> 'b) -> 'c -> 'd -> 'b
  val it_union :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) -> ('a -> 'b -> 'b) -> 'c -> 'b -> 'b
  val iti_ball :
    ((bool -> bool) -> ('a -> bool -> bool) -> 'b -> bool -> bool) ->
      'b -> ('a -> bool) -> bool
  val rm_empty : 'a linorder -> ('a, 'b) rbt
  val emptyc : 'a hashable -> (Big_int.big_int, ('a, 'b) assoc_list) rbt
  val hm_empty : 'a hashable -> ('a, 'b) hashmap
  val s_empty : 'a -> 'a
  val hs_empty : 'a hashable -> ('a, unit) hashmap
  val lh_image_filter :
    'b equal * 'b hashable ->
      ('a -> 'b option) -> 'a dlist -> ('b, unit) hashmap
  val brc_iq :
    'a equal * 'a hashable -> ('a, 'b) ta_rule dlist -> ('a, unit) hashmap
  val hta_Qi : ('a, 'b, 'c) hashedTa_ext -> ('a, unit) hashmap
  val mod_nat : Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val fifo_empty : 'a list * 'a list
  val s_memb : ('a -> 'b -> 'c option) -> 'a -> 'b -> bool
  val hs_memb : 'a equal * 'a hashable -> 'a -> ('a, unit) hashmap -> bool
  val s_iterate :
    (('a -> unit -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
      ('a -> 'b -> 'b) -> 'c -> 'b -> 'b
  val hs_iterate :
    'a hashable -> ('a -> 'b -> 'b) -> ('a, unit) hashmap -> 'b -> 'b
  val hs_size : 'a hashable -> ('a, unit) hashmap -> Big_int.big_int
  val equal_ta_rulea :
    'a equal -> 'b equal -> ('a, 'b) ta_rule -> ('a, 'b) ta_rule -> bool
  val equal_ta_rule : 'a equal -> 'b equal -> ('a, 'b) ta_rule equal
  val ls_ball : 'a dlist -> ('a -> bool) -> bool
  val ball_disjoint :
    ('a -> ('b -> bool) -> 'c) -> ('b -> 'd -> bool) -> 'a -> 'd -> 'c
  val lh_disjoint :
    'a equal * 'a hashable -> 'a dlist -> ('a, unit) hashmap -> bool
  val hta_mema :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'a tree -> ('b, 'a, 'c) hashedTa_ext -> bool
  val hta_delta : ('a, 'b, 'c) hashedTa_ext -> ('a, 'b) ta_rule dlist
  val hta_idx_f_update :
    (('a, ('b, 'a) ta_rule dlist) hashmap option ->
      ('a, ('b, 'a) ta_rule dlist) hashmap option) ->
      ('b, 'a, 'c) hashedTa_ext -> ('b, 'a, 'c) hashedTa_ext
  val idx_build_stepfun :
    ('a -> 'b -> 'c option) ->
      ('a -> 'c -> 'b -> 'b) ->
        'c -> ('d -> 'c -> 'c) -> ('d -> 'a) -> 'd -> 'b -> 'b
  val idx_build :
    'a -> ('b -> 'a -> 'c option) ->
            ('b -> 'c -> 'a -> 'a) ->
              'c -> ('d -> 'c -> 'c) ->
                      (('d -> 'a -> 'a) -> 'e -> 'a -> 'a) ->
                        ('d -> 'b) -> 'e -> 'a
  val hll_idx_build :
    'a equal -> 'b equal * 'b hashable ->
      ('a -> 'b) -> 'a dlist -> ('b, 'a dlist) hashmap
  val build_rule_index :
    'a equal -> 'b equal -> 'c equal * 'c hashable ->
      (('a, 'b) ta_rule -> 'c) ->
        ('a, 'b) ta_rule dlist -> ('c, ('a, 'b) ta_rule dlist) hashmap
  val build_rule_index_f :
    'a equal -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> ('b, ('a, 'b) ta_rule dlist) hashmap
  val hta_ensure_idx_f :
    'a equal -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val hta_mem :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'a tree -> ('b, 'a, 'c) hashedTa_ext -> bool
  val pa_cond :
    'a hashable -> 'b hashable -> 'c hashable ->
      (('a * 'b), unit) hashmap *
        (('a * 'b) list * (('a * 'b), 'c) ta_rule dlist) ->
        bool
  val hashcode_prod : 'a hashable -> 'b hashable -> 'a * 'b -> Big_int.big_int
  val bounded_hashcode_prod :
    'a hashable -> 'b hashable -> Big_int.big_int -> 'a * 'b -> Big_int.big_int
  val def_hashmap_size_prod :
    'a hashable -> 'b hashable -> ('a * 'b) itself -> Big_int.big_int
  val hashable_prod : 'a hashable -> 'b hashable -> ('a * 'b) hashable
  val equal_proda : 'a equal -> 'b equal -> 'a * 'b -> 'a * 'b -> bool
  val equal_prod : 'a equal -> 'b equal -> ('a * 'b) equal
  val pa_upd_rule :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      (('a * 'b), unit) hashmap ->
        ('a * 'b) list ->
          ('a * 'b) list -> (('a * 'b), unit) hashmap * ('a * 'b) list
  val hta_idx_s :
    ('a, 'b, 'c) hashedTa_ext -> ('a, ('a, 'b) ta_rule dlist) hashmap option
  val hta_lookup_s :
    'a equal * 'a hashable ->
      'a -> ('a, 'b, 'c) hashedTa_ext -> ('a, 'b) ta_rule dlist
  val ls_ins_dj : 'a equal -> 'a -> 'a dlist -> 'a dlist
  val hta_idx_sf :
    ('a, 'b, 'c) hashedTa_ext ->
      (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option
  val hta_lookup_sf :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'a -> 'b -> ('a, 'b, 'c) hashedTa_ext -> ('a, 'b) ta_rule dlist
  val pa_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext ->
          (('a * 'c), unit) hashmap *
            (('a * 'c) list * (('a * 'c), 'b) ta_rule dlist) ->
            (('a * 'c), unit) hashmap *
              (('a * 'c) list * (('a * 'c), 'b) ta_rule dlist)
  val map_to_nat :
    (('a -> Big_int.big_int * 'b -> Big_int.big_int * 'b) ->
      'c -> Big_int.big_int * 'b -> Big_int.big_int * 'b) ->
      'b -> ('a -> Big_int.big_int -> 'b -> 'b) -> 'c -> 'b
  val equal_dlista : 'a equal -> 'a dlist -> 'a dlist -> bool
  val equal_dlist : 'a equal -> 'a dlist equal
  val iflt_image : (('a -> 'b option) -> 'c -> 'd) -> ('a -> 'b) -> 'c -> 'd
  val hs_image_filter :
    'a hashable -> 'b equal * 'b hashable ->
      ('a -> 'b option) -> ('a, unit) hashmap -> ('b, unit) hashmap
  val hs_image :
    'a hashable -> 'b equal * 'b hashable ->
      ('a -> 'b) -> ('a, unit) hashmap -> ('b, unit) hashmap
  val s_ins_dj : ('a -> unit -> 'b -> 'c) -> 'a -> 'b -> 'c
  val hm_update_dj :
    'a equal * 'a hashable -> 'a -> 'b -> ('a, 'b) hashmap -> ('a, 'b) hashmap
  val hs_ins_dj :
    'a equal * 'a hashable -> 'a -> ('a, unit) hashmap -> ('a, unit) hashmap
  val hs_inter :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, unit) hashmap -> ('a, unit) hashmap
  val s_union : 'a -> 'a
  val hs_union :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, unit) hashmap -> ('a, unit) hashmap
  val hhh_cart :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, unit) hashmap -> ('b, unit) hashmap -> (('a * 'b), unit) hashmap
  val brc_cond :
    'a hashable -> 'b hashable ->
      ('a, unit) hashmap *
        ('a list * (('a, 'b) ta_rule, Big_int.big_int) hashmap) ->
        bool
  val rqrm_lookup :
    'a equal * 'a hashable -> ('a, 'b dlist) hashmap -> 'a -> 'b dlist
  val hashcode_list : 'a hashable -> 'a list -> Big_int.big_int
  val hashcode_of_ta_rule :
    'a hashable -> 'b hashable -> ('a, 'b) ta_rule -> Big_int.big_int
  val hashcode_ta_rule :
    'a hashable -> 'b hashable -> ('a, 'b) ta_rule -> Big_int.big_int
  val bounded_hashcode_ta_rule :
    'a hashable -> 'b hashable ->
      Big_int.big_int -> ('a, 'b) ta_rule -> Big_int.big_int
  val def_hashmap_size_ta_rule :
    'a hashable -> 'b hashable -> ('a, 'b) ta_rule itself -> Big_int.big_int
  val hashable_ta_rule : 'a hashable -> 'b hashable -> ('a, 'b) ta_rule hashable
  val brc_inner_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule ->
        ('a, unit) hashmap *
          ('a list * (('a, 'b) ta_rule, Big_int.big_int) hashmap) ->
          ('a, unit) hashmap *
            ('a list * (('a, 'b) ta_rule, Big_int.big_int) hashmap)
  val brc_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, ('a, 'b) ta_rule dlist) hashmap ->
        ('a, unit) hashmap *
          ('a list * (('a, 'b) ta_rule, Big_int.big_int) hashmap) ->
          ('a, unit) hashmap *
            ('a list * (('a, 'b) ta_rule, Big_int.big_int) hashmap)
  val brec_iqm :
    'a equal * 'a hashable -> 'b hashable ->
      ('a, 'b) ta_rule dlist -> ('a, 'b tree) hashmap
  val init_hta :
    ('a, unit) hashmap -> ('a, 'b) ta_rule dlist -> ('a, 'b, unit) hashedTa_ext
  val it_set_to_list :
    (('a -> 'a list -> 'a list) -> 'b -> 'c list -> 'a list) -> 'b -> 'a list
  val hs_to_list : 'a hashable -> ('a, unit) hashmap -> 'a list
  val pa_initial :
    'a equal * 'a hashable -> 'b hashable -> 'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext ->
          (('a * 'c), unit) hashmap *
            (('a * 'c) list * (('a * 'c), 'b) ta_rule dlist)
  val while_option : ('a -> bool) -> ('a -> 'a) -> 'a -> 'a option
  val whilea : ('a -> bool) -> ('a -> 'a) -> 'a -> 'a
  val hta_proda :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext -> (('a * 'c), 'b, unit) hashedTa_ext
  val hta_idx_s_update :
    (('a, ('a, 'b) ta_rule dlist) hashmap option ->
      ('a, ('a, 'b) ta_rule dlist) hashmap option) ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val build_rule_index_s :
    'a equal * 'a hashable -> 'b equal ->
      ('a, 'b) ta_rule dlist -> ('a, ('a, 'b) ta_rule dlist) hashmap
  val hta_ensure_idx_s :
    'a equal * 'a hashable -> 'b equal ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val hta_idx_sf_update :
    ((('a * 'b), ('a, 'b) ta_rule dlist) hashmap option ->
      (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option) ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val build_rule_index_sf :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> (('a * 'b), ('a, 'b) ta_rule dlist) hashmap
  val hta_ensure_idx_sf :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val hta_prod :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext -> (('a * 'c), 'b, unit) hashedTa_ext
  val hashcode_nat : Big_int.big_int -> Big_int.big_int
  val bounded_hashcode_nat :
    Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val def_hashmap_size_nat : Big_int.big_int itself -> Big_int.big_int
  val hashable_nat : Big_int.big_int hashable
  val htai_mem :
    Big_int.big_int tree ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext -> bool
  val rqrm_add :
    'a equal * 'a hashable -> 'b equal ->
      'a -> 'b -> ('a, 'b dlist) hashmap -> ('a, 'b dlist) hashmap
  val fifo_dequeue : 'a list * 'a list -> 'a * ('a list * 'a list)
  val fifo_enqueue : 'a -> 'a list * 'a list -> 'a list * 'a list
  val fifo_isEmpty : 'a equal -> 'a list * 'a list -> bool
  val lhh_union :
    'a equal * 'a hashable ->
      'a dlist -> ('a, unit) hashmap -> ('a, unit) hashmap
  val brec_cond :
    'a equal ->
      ('a, 'b tree) hashmap *
        (('a list * 'a list) *
          ((('a, 'b) ta_rule, Big_int.big_int) hashmap * 'a option)) ->
        bool
  val brec_construct_witness :
    'a equal * 'a hashable -> 'b hashable ->
      ('a, 'b tree) hashmap -> ('a, 'b) ta_rule -> 'b tree
  val brec_inner_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, unit) hashmap ->
        ('a, 'b) ta_rule ->
          ('a, 'b tree) hashmap *
            (('a list * 'a list) *
              ((('a, 'b) ta_rule, Big_int.big_int) hashmap * 'a option)) ->
            ('a, 'b tree) hashmap *
              (('a list * 'a list) *
                ((('a, 'b) ta_rule, Big_int.big_int) hashmap * 'a option))
  val brec_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, ('a, 'b) ta_rule dlist) hashmap ->
        ('a, unit) hashmap ->
          ('a, 'b tree) hashmap *
            (('a list * 'a list) *
              ((('a, 'b) ta_rule, Big_int.big_int) hashmap * 'a option)) ->
            ('a, 'b tree) hashmap *
              (('a list * 'a list) *
                ((('a, 'b) ta_rule, Big_int.big_int) hashmap * 'a option))
  val hta_empty : 'a hashable -> 'b hashable -> ('a, 'b, unit) hashedTa_ext
  val ls_image : 'b equal -> ('a -> 'b) -> 'a dlist -> 'b dlist
  val hta_remap :
    'a hashable -> 'b equal * 'b hashable -> 'c equal * 'c hashable ->
      ('a -> 'b) -> ('a, 'c, unit) hashedTa_ext -> ('b, 'c, unit) hashedTa_ext
  val equal_ustate_wrappera :
    'a equal -> 'b equal ->
      ('a, 'b) ustate_wrapper -> ('a, 'b) ustate_wrapper -> bool
  val equal_ustate_wrapper :
    'a equal -> 'b equal -> ('a, 'b) ustate_wrapper equal
  val ls_union : 'a equal -> 'a dlist -> 'a dlist -> 'a dlist
  val ls_union_dj : 'a equal -> 'a dlist -> 'a dlist -> 'a dlist
  val hashcode_ustate_wrapper :
    'a hashable -> 'b hashable -> ('a, 'b) ustate_wrapper -> Big_int.big_int
  val bounded_hashcode_ustate_wrapper :
    'a hashable -> 'b hashable ->
      Big_int.big_int -> ('a, 'b) ustate_wrapper -> Big_int.big_int
  val def_hashmap_size_ustate_wrapper :
    'a hashable -> 'b hashable ->
      ('a, 'b) ustate_wrapper itself -> Big_int.big_int
  val hashable_ustate_wrapper :
    'a hashable -> 'b hashable -> ('a, 'b) ustate_wrapper hashable
  val hta_union :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext ->
          (('a, 'c) ustate_wrapper, 'b, unit) hashedTa_ext
  val list_to_ls : 'a equal -> 'a list -> 'a dlist
  val rule_states_l : 'a equal -> ('a, 'b) ta_rule -> 'a dlist
  val it_Union_image :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
      'b -> ('d -> 'b -> 'b) -> ('a -> 'd) -> 'c -> 'b
  val llh_Union_image :
    'b equal * 'b hashable -> ('a -> 'b dlist) -> 'a dlist -> ('b, unit) hashmap
  val hta_delta_states :
    'a equal * 'a hashable -> ('a, 'b, 'c) hashedTa_ext -> ('a, unit) hashmap
  val hta_states :
    'a equal * 'a hashable -> ('a, 'b, 'c) hashedTa_ext -> ('a, unit) hashmap
  val hh_map_to_nat :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, Big_int.big_int) hashmap
  val hta_reindex :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, unit) hashedTa_ext -> (Big_int.big_int, 'b, unit) hashedTa_ext
  val htai_prod :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
        (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val rs_iterate : 'a linorder -> ('a -> 'b -> 'b) -> ('a, unit) rbt -> 'b -> 'b
  val rs_size : 'a linorder -> ('a, unit) rbt -> Big_int.big_int
  val it_set_to_List_enq :
    (('a -> 'b -> 'b) -> 'c -> 'b -> 'b) -> 'b -> ('a -> 'b -> 'b) -> 'c -> 'b
  val it_set_to_fifo :
    (('a -> 'a list * 'a list -> 'a list * 'a list) ->
      'b -> 'a list * 'a list -> 'a list * 'a list) ->
      'b -> 'a list * 'a list
  val hs_to_fifo : 'a hashable -> ('a, unit) hashmap -> 'a list * 'a list
  val build_rqrm :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> ('a, ('a, 'b) ta_rule dlist) hashmap
  val hta_add_qi :
    'a equal * 'a hashable -> 'b hashable ->
      'a -> ('a, 'b, unit) hashedTa_ext -> ('a, 'b, unit) hashedTa_ext
  val lll_inj_image_filter_cp :
    'c equal ->
      ('a -> 'b -> 'c) -> ('a -> 'b -> bool) -> 'a dlist -> 'b dlist -> 'c dlist
  val delta_prod_h :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b) ta_rule dlist ->
        ('c, 'b) ta_rule dlist -> (('a * 'c), 'b) ta_rule dlist
  val hta_prodWR :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'd equal * 'd hashable ->
      ('a, 'b, 'c) hashedTa_ext ->
        ('d, 'b, 'e) hashedTa_ext -> (('a * 'd), 'b, unit) hashedTa_ext
  val hta_reduce :
    'a equal * 'a hashable -> 'b equal ->
      ('a, 'b, 'c) hashedTa_ext ->
        ('a, unit) hashmap -> ('a, 'b, unit) hashedTa_ext
  val htai_empty : (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val htai_union :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
        (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val ls_size : 'a dlist -> Big_int.big_int
  val brc_rcm_init :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> (('a, 'b) ta_rule, Big_int.big_int) hashmap
  val brc_initial :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist ->
        ('a, unit) hashmap *
          ('a list * (('a, 'b) ta_rule, Big_int.big_int) hashmap)
  val htai_add_qi :
    Big_int.big_int ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
        (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val htai_prodWR :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
        (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val sel_disjoint_witness :
    ('a -> ('b -> 'b option) -> 'c) -> ('b -> 'd -> bool) -> 'a -> 'd -> 'c
  val hh_disjoint_witness :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, unit) hashmap -> 'a option
  val brec_initial :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, unit) hashmap ->
        ('a, 'b) ta_rule dlist ->
          ('a, 'b tree) hashmap *
            (('a list * 'a list) *
              ((('a, 'b) ta_rule, Big_int.big_int) hashmap * 'a option))
  val hta_add_rule :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule ->
        ('a, 'b, unit) hashedTa_ext -> ('a, 'b, unit) hashedTa_ext
  val htai_add_rule :
    (Big_int.big_int, Big_int.big_int) ta_rule ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
        (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val hta_bwd_reduce :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, unit) hashedTa_ext
  val htai_bwd_reduce :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val htai_ensure_idx_f :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val htai_ensure_idx_s :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val htai_ensure_idx_sf :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  val hta_is_empty_witness :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> 'b tree option
  val htai_is_empty_witness :
    (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext ->
      Big_int.big_int tree option
end = struct

let rec id x = (fun xa -> xa) x;;

type 'a equal = {equal : 'a -> 'a -> bool};;
let equal _A = _A.equal;;

let rec eq _A a b = equal _A a b;;

type color = R | B;;

type ('a, 'b) rbta = Empty |
  Branch of color * ('a, 'b) rbta * 'a * 'b * ('a, 'b) rbta;;

type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool};;
let less_eq _A = _A.less_eq;;
let less _A = _A.less;;

type 'a preorder = {ord_preorder : 'a ord};;

type 'a order = {preorder_order : 'a preorder};;

type 'a linorder = {order_linorder : 'a order};;

type ('a, 'b) rbt = Rbt of ('a, 'b) rbta;;

type ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list;;

let rec lhs (Rule (q, l, qs)) = q;;

let rec hd (x :: xs) = x;;

let rec tl = function [] -> []
             | x :: xs -> xs;;

let rec suc n = Big_int.add_big_int n (Big_int.big_int_of_int 1);;

let rec rhsl (Rule (q, l, qs)) = l;;

let rec rhsq (Rule (q, l, qs)) = qs;;

type ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b;;

let rec comp f g = (fun x -> f (g x));;

let rec map
  f x1 = match f, x1 with f, [] -> []
    | f, x :: xs -> f x :: map f xs;;

let rec fold
  f x1 = match f, x1 with f, [] -> id
    | f, x :: xs -> comp (fold f xs) (f x);;

let rec rev xs = fold (fun a b -> a :: b) xs [];;

let rec zip
  xs ys = match xs, ys with x :: xs, y :: ys -> (x, y) :: zip xs ys
    | xs, [] -> []
    | [], ys -> [];;

type 'a tree = Node of 'a * 'a tree list;;

let rec null = function [] -> true
               | x :: xs -> false;;

type 'a itself = Type;;

let rec empty _A = Rbt Empty;;

let rec r_prod
  (Rule (q1, l1, qs1)) (Rule (q2, l2, qs2)) = Rule ((q1, q2), l1, zip qs1 qs2);;

type 'a dlist = Dlist of 'a list;;

let rec foldl
  f a x2 = match f, a, x2 with f, a, [] -> a
    | f, a, x :: xs -> foldl f (f a x) xs;;

let rec map_of _A
  x0 k = match x0, k with
    (l, v) :: ps, k -> (if eq _A l k then Some v else map_of _A ps k)
    | [], k -> None;;

let ord_nat =
  ({less_eq = Big_int.le_big_int; less = Big_int.lt_big_int} :
    Big_int.big_int ord);;

let rec the (Some x) = x;;

let rec impl_of _A (Rbt x) = x;;

let rec balance
  x0 s t x3 = match x0, s, t, x3 with
    Branch (R, a, w, x, b), s, t, Branch (R, c, y, z, d) ->
      Branch (R, Branch (B, a, w, x, b), s, t, Branch (B, c, y, z, d))
    | Branch (R, Branch (R, a, w, x, b), s, t, c), y, z, Empty ->
        Branch (R, Branch (B, a, w, x, b), s, t, Branch (B, c, y, z, Empty))
    | Branch (R, Branch (R, a, w, x, b), s, t, c), y, z,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (R, Branch (B, a, w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Branch (R, Empty, w, x, Branch (R, b, s, t, c)), y, z, Empty ->
        Branch (R, Branch (B, Empty, w, x, b), s, t, Branch (B, c, y, z, Empty))
    | Branch (R, Branch (B, va, vb, vc, vd), w, x, Branch (R, b, s, t, c)), y,
        z, Empty
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, Empty))
    | Branch (R, Empty, w, x, Branch (R, b, s, t, c)), y, z,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (R, Branch (B, Empty, w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Branch (R, Branch (B, ve, vf, vg, vh), w, x, Branch (R, b, s, t, c)), y,
        z, Branch (B, va, vb, vc, vd)
        -> Branch
             (R, Branch (B, Branch (B, ve, vf, vg, vh), w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Empty, w, x, Branch (R, b, s, t, Branch (R, c, y, z, d)) ->
        Branch (R, Branch (B, Empty, w, x, b), s, t, Branch (B, c, y, z, d))
    | Branch (B, va, vb, vc, vd), w, x,
        Branch (R, b, s, t, Branch (R, c, y, z, d))
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, d))
    | Empty, w, x, Branch (R, Branch (R, b, s, t, c), y, z, Empty) ->
        Branch (R, Branch (B, Empty, w, x, b), s, t, Branch (B, c, y, z, Empty))
    | Empty, w, x,
        Branch (R, Branch (R, b, s, t, c), y, z, Branch (B, va, vb, vc, vd))
        -> Branch
             (R, Branch (B, Empty, w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Branch (B, va, vb, vc, vd), w, x,
        Branch (R, Branch (R, b, s, t, c), y, z, Empty)
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, Empty))
    | Branch (B, va, vb, vc, vd), w, x,
        Branch (R, Branch (R, b, s, t, c), y, z, Branch (B, ve, vf, vg, vh))
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, ve, vf, vg, vh)))
    | Empty, s, t, Empty -> Branch (B, Empty, s, t, Empty)
    | Empty, s, t, Branch (B, va, vb, vc, vd) ->
        Branch (B, Empty, s, t, Branch (B, va, vb, vc, vd))
    | Empty, s, t, Branch (v, Empty, vb, vc, Empty) ->
        Branch (B, Empty, s, t, Branch (v, Empty, vb, vc, Empty))
    | Empty, s, t, Branch (v, Branch (B, ve, vf, vg, vh), vb, vc, Empty) ->
        Branch
          (B, Empty, s, t,
            Branch (v, Branch (B, ve, vf, vg, vh), vb, vc, Empty))
    | Empty, s, t, Branch (v, Empty, vb, vc, Branch (B, vf, vg, vh, vi)) ->
        Branch
          (B, Empty, s, t,
            Branch (v, Empty, vb, vc, Branch (B, vf, vg, vh, vi)))
    | Empty, s, t,
        Branch
          (v, Branch (B, ve, vj, vk, vl), vb, vc, Branch (B, vf, vg, vh, vi))
        -> Branch
             (B, Empty, s, t,
               Branch
                 (v, Branch (B, ve, vj, vk, vl), vb, vc,
                   Branch (B, vf, vg, vh, vi)))
    | Branch (B, va, vb, vc, vd), s, t, Empty ->
        Branch (B, Branch (B, va, vb, vc, vd), s, t, Empty)
    | Branch (B, va, vb, vc, vd), s, t, Branch (B, ve, vf, vg, vh) ->
        Branch (B, Branch (B, va, vb, vc, vd), s, t, Branch (B, ve, vf, vg, vh))
    | Branch (B, va, vb, vc, vd), s, t, Branch (v, Empty, vf, vg, Empty) ->
        Branch
          (B, Branch (B, va, vb, vc, vd), s, t,
            Branch (v, Empty, vf, vg, Empty))
    | Branch (B, va, vb, vc, vd), s, t,
        Branch (v, Branch (B, vi, vj, vk, vl), vf, vg, Empty)
        -> Branch
             (B, Branch (B, va, vb, vc, vd), s, t,
               Branch (v, Branch (B, vi, vj, vk, vl), vf, vg, Empty))
    | Branch (B, va, vb, vc, vd), s, t,
        Branch (v, Empty, vf, vg, Branch (B, vj, vk, vl, vm))
        -> Branch
             (B, Branch (B, va, vb, vc, vd), s, t,
               Branch (v, Empty, vf, vg, Branch (B, vj, vk, vl, vm)))
    | Branch (B, va, vb, vc, vd), s, t,
        Branch
          (v, Branch (B, vi, vn, vo, vp), vf, vg, Branch (B, vj, vk, vl, vm))
        -> Branch
             (B, Branch (B, va, vb, vc, vd), s, t,
               Branch
                 (v, Branch (B, vi, vn, vo, vp), vf, vg,
                   Branch (B, vj, vk, vl, vm)))
    | Branch (v, Empty, vb, vc, Empty), s, t, Empty ->
        Branch (B, Branch (v, Empty, vb, vc, Empty), s, t, Empty)
    | Branch (v, Empty, vb, vc, Branch (B, ve, vf, vg, vh)), s, t, Empty ->
        Branch
          (B, Branch (v, Empty, vb, vc, Branch (B, ve, vf, vg, vh)), s, t,
            Empty)
    | Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Empty), s, t, Empty ->
        Branch
          (B, Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Empty), s, t,
            Empty)
    | Branch
        (v, Branch (B, vf, vg, vh, vi), vb, vc, Branch (B, ve, vj, vk, vl)),
        s, t, Empty
        -> Branch
             (B, Branch
                   (v, Branch (B, vf, vg, vh, vi), vb, vc,
                     Branch (B, ve, vj, vk, vl)),
               s, t, Empty)
    | Branch (v, Empty, vf, vg, Empty), s, t, Branch (B, va, vb, vc, vd) ->
        Branch
          (B, Branch (v, Empty, vf, vg, Empty), s, t,
            Branch (B, va, vb, vc, vd))
    | Branch (v, Empty, vf, vg, Branch (B, vi, vj, vk, vl)), s, t,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (B, Branch (v, Empty, vf, vg, Branch (B, vi, vj, vk, vl)), s, t,
               Branch (B, va, vb, vc, vd))
    | Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (B, Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
               Branch (B, va, vb, vc, vd))
    | Branch
        (v, Branch (B, vj, vk, vl, vm), vf, vg, Branch (B, vi, vn, vo, vp)),
        s, t, Branch (B, va, vb, vc, vd)
        -> Branch
             (B, Branch
                   (v, Branch (B, vj, vk, vl, vm), vf, vg,
                     Branch (B, vi, vn, vo, vp)),
               s, t, Branch (B, va, vb, vc, vd));;

let rec ins _A
  f k v x3 = match f, k, v, x3 with
    f, k, v, Empty -> Branch (R, Empty, k, v, Empty)
    | f, k, v, Branch (B, l, x, y, r) ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then balance (ins _A f k v l) x y r
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then balance l x y (ins _A f k v r)
                 else Branch (B, l, x, f k y v, r)))
    | f, k, v, Branch (R, l, x, y, r) ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then Branch (R, ins _A f k v l, x, y, r)
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then Branch (R, l, x, y, ins _A f k v r)
                 else Branch (R, l, x, f k y v, r)));;

let rec paint
  c x1 = match c, x1 with c, Empty -> Empty
    | c, Branch (uu, l, k, v, r) -> Branch (c, l, k, v, r);;

let rec insert_with_key _A f k v t = paint B (ins _A f k v t);;

let rec insertc _A = insert_with_key _A (fun _ _ nv -> nv);;

let rec insert _A k v t = Rbt (insertc _A k v (impl_of _A t));;

let rec lookupa _A
  x0 k = match x0, k with Empty, k -> None
    | Branch (uu, l, x, y, r), k ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then lookupa _A l k
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then lookupa _A r k else Some y));;

let rec lookup _A t = lookupa _A (impl_of _A t);;

let rec inj_image_filter_cp
  iterate1 iterate2 empty3 insert_dj3 f p s1 s2 =
    iterate1
      (fun x ->
        iterate2 (fun y res -> (if p x y then insert_dj3 (f x y) res else res))
          s2)
      s1
      empty3;;

let rec cart
  it1 it2 empty3 ins3 s1 s2 =
    inj_image_filter_cp it1 it2 empty3 ins3 (fun a b -> (a, b))
      (fun _ _ -> true) s1 s2;;

let emptya : 'a dlist = Dlist [];;

let rec member _A
  x0 y = match x0, y with [], y -> false
    | x :: xs, y -> eq _A x y || member _A xs y;;

let rec inserta _A x xs = (if member _A xs x then xs else x :: xs);;

let rec list_of_dlist (Dlist x) = x;;

let rec insertb _A x dxs = Dlist (inserta _A x (list_of_dlist dxs));;

let rec membera _A dxs = member _A (list_of_dlist dxs);;

let rec remdups _A
  = function [] -> []
    | x :: xs ->
        (if member _A xs x then remdups _A xs else x :: remdups _A xs);;

let rec it_add update iterate m1 m2 = iterate update m2 m1;;

let equal_nat = ({equal = Big_int.eq_big_int} : Big_int.big_int equal);;

let preorder_nat = ({ord_preorder = ord_nat} : Big_int.big_int preorder);;

let order_nat = ({preorder_order = preorder_nat} : Big_int.big_int order);;

let rec list_all
  p x1 = match p, x1 with p, [] -> true
    | p, x :: xs -> p x && list_all p xs;;

let rec is_none = function Some x -> false
                  | None -> true;;

let rec iti_sel iti m f = iti is_none (fun k v _ -> f k v) m None;;

let rec map_sng empt update k v = update k v empt;;

let rec minus_nat
  n m = Big_int.max_big_int Big_int.zero_big_int (Big_int.sub_big_int n m);;

let rec it_size
  iterate s = iterate (fun _ -> suc) s (Big_int.big_int_of_int 0);;

let rec remap_rule f (Rule (q, l, qs)) = Rule (f q, l, map f qs);;

type 'a hashable =
  {hashcode : 'a -> Big_int.big_int;
    bounded_hashcode : Big_int.big_int -> 'a -> Big_int.big_int;
    def_hashmap_size : 'a itself -> Big_int.big_int};;
let hashcode _A = _A.hashcode;;
let bounded_hashcode _A = _A.bounded_hashcode;;
let def_hashmap_size _A = _A.def_hashmap_size;;

let rec list_all_zip
  p x1 x2 = match p, x1, x2 with p, [], [] -> true
    | p, a :: asa, b :: bs -> p a b && list_all_zip p asa bs
    | p, v :: va, [] -> false
    | p, [], v :: va -> false;;

let rec ls_memb _A x l = membera _A l x;;

type ('a, 'b) assoc_list = Assoc_List of ('a * 'b) list;;

type ('a, 'b) hashmap = RBT_HM of (Big_int.big_int, ('a, 'b) assoc_list) rbt;;

type ('a, 'b, 'c) hashedTa_ext =
  HashedTa_ext of
    ('a, unit) hashmap * ('a, 'b) ta_rule dlist *
      ('b, ('a, 'b) ta_rule dlist) hashmap option *
      ('a, ('a, 'b) ta_rule dlist) hashmap option *
      (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option * 'c;;

let rec hta_idx_f
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_idx_f;;

let linorder_nat = ({order_linorder = order_nat} : Big_int.big_int linorder);;

let rec rm_lookup _A k m = lookup _A m k;;

let rec impl_ofa (Assoc_List x) = x;;

let rec lookupb _A al = map_of _A (impl_ofa al);;

let rec lm_lookup _A k m = lookupb _A m k;;

let rec lookupc (_A1, _A2)
  k m = (match rm_lookup linorder_nat (hashcode _A2 k) m with None -> None
          | Some a -> lm_lookup _A1 k a);;

let rec impl_of_RBT_HM _A (RBT_HM x) = x;;

let rec hm_lookup (_A1, _A2)
  k hm = lookupc (_A1, _A2) k (impl_of_RBT_HM _A2 hm);;

let rec idx_lookup
  mlookup tempty i m = (match mlookup i m with None -> tempty | Some s -> s);;

let ls_empty : 'a dlist = emptya;;

let rec hl_idx_lookup (_A1, _A2) = idx_lookup (hm_lookup (_A1, _A2)) ls_empty;;

let rec hta_lookup_f (_A1, _A2)
  f h = hl_idx_lookup (_A1, _A2) f (the (hta_idx_f h));;

let rec ls_ins _A = insertb _A;;

let rec it_image_filter
  iterate1 empty2 ins2 f s =
    iterate1 (fun x res -> (match f x with None -> res | Some v -> ins2 v res))
      s
      empty2;;

let rec iti_iteratea iti = iti (fun _ -> true);;

let rec iteratei_aux
  c f x2 sigma = match c, f, x2, sigma with c, f, [], sigma -> sigma
    | c, f, x :: xs, sigma ->
        (if c sigma then iteratei_aux c f xs (f x sigma) else sigma);;

let rec iteratei c f xs = iteratei_aux c f (list_of_dlist xs);;

let rec ls_iteratei x = iteratei x;;

let rec ls_iterate x = iti_iteratea ls_iteratei x;;

let rec ls_image_filter _B = it_image_filter ls_iterate ls_empty (ls_ins _B);;

let rec faccs _A (_B1, _B2)
  h (Node (f, ts)) =
    let qs = map (faccs _A (_B1, _B2) h) ts in
    ls_image_filter _A
      (fun r ->
        let Rule (_, _, qsa) = r in
        (if list_all_zip (fun q qa -> ls_memb _A qa q) qs qsa then Some (lhs r)
          else None))
      (hta_lookup_f (_B1, _B2) f h);;

let emptyb : ('a, 'b) assoc_list = Assoc_List [];;

let lm_empty : ('a, 'b) assoc_list = emptyb;;

let rec fst (a, b) = a;;

let rec snd (a, b) = b;;

let rec update_with_aux _B
  v k f x3 = match v, k, f, x3 with v, k, f, [] -> [(k, f v)]
    | v, k, f, p :: ps ->
        (if eq _B (fst p) k then (k, f (snd p)) :: ps
          else p :: update_with_aux _B v k f ps);;

let rec update_with _A
  v k f al = Assoc_List (update_with_aux _A v k f (impl_ofa al));;

let rec update _A k v = update_with _A v k (fun _ -> v);;

let rec lm_update _A = update _A;;

let rec lm_sng _A = map_sng lm_empty (lm_update _A);;

let rec rm_update _A = insert _A;;

let rec updatea (_A1, _A2)
  k v m =
    let hc = hashcode _A2 k in
    (match rm_lookup linorder_nat hc m
      with None -> rm_update linorder_nat hc (lm_sng _A1 k v) m
      | Some bm -> rm_update linorder_nat hc (lm_update _A1 k v bm) m);;

let rec hm_update (_A1, _A2)
  k v hm = RBT_HM (updatea (_A1, _A2) k v (impl_of_RBT_HM _A2 hm));;

let rec itoi_iterateo it = it (fun _ -> true);;

let rec rm_iterateoi
  c f x2 sigma = match c, f, x2, sigma with c, f, Empty, sigma -> sigma
    | c, f, Branch (col, l, k, v, r), sigma ->
        (if c sigma
          then let sigmaa = rm_iterateoi c f l sigma in
               (if c sigmaa then rm_iterateoi c f r (f k v sigmaa) else sigmaa)
          else sigma);;

let rec rm_iterateoia _B c f r = rm_iterateoi c f (impl_of _B r);;

let rec rm_iterateo _A = itoi_iterateo (rm_iterateoia _A);;

let rec rm_iterate _A = rm_iterateo _A;;

let rec iti_iterate iti = iti (fun _ -> true);;

let rec iteratei_auxa
  c f x2 sigma = match c, f, x2, sigma with c, f, [], sigma -> sigma
    | c, f, (k, v) :: l, sigma ->
        (if c sigma then iteratei_auxa c f l (f k v sigma) else sigma);;

let rec iterateia c f al = iteratei_auxa c f (impl_ofa al);;

let rec lm_iteratei x = iterateia x;;

let rec lm_iterate x = iti_iterate lm_iteratei x;;

let rec iterate _D
  f m sigma_0 = rm_iterate _D (fun _ -> lm_iterate f) m sigma_0;;

let rec hm_iterate _A f hm = iterate linorder_nat f (impl_of_RBT_HM _A hm);;

let rec hm_add (_A1, _A2) = it_add (hm_update (_A1, _A2)) (hm_iterate _A2);;

let rec rm_iteratei _B = rm_iterateoia _B;;

let rec rm_sel _A = iti_sel (rm_iteratei _A);;

let rec lm_sel x = iti_sel lm_iteratei x;;

let rec sel _A m f = rm_sel linorder_nat m (fun _ lm -> lm_sel lm f);;

let rec hm_sel _A hm = sel _A (impl_of_RBT_HM _A hm);;

let rec s_ins update x s = update x () s;;

let rec hs_ins (_A1, _A2) = s_ins (hm_update (_A1, _A2));;

let rec s_sel sel s f = sel s (fun u _ -> f u);;

let rec hs_sel _A = s_sel (hm_sel _A);;

let rec equal_lista _A
  x0 x1 = match x0, x1 with a :: lista, [] -> false
    | [], a :: lista -> false
    | aa :: listaa, a :: lista -> eq _A aa a && equal_lista _A listaa lista
    | [], [] -> true;;

let rec equal_list _A = ({equal = equal_lista _A} : ('a list) equal);;

let rec size_list
  = function [] -> (Big_int.big_int_of_int 0)
    | a :: lista ->
        Big_int.add_big_int (size_list lista) (suc (Big_int.big_int_of_int 0));;

let rec it_inter
  iterate1 memb2 empt3 insrt3 s1 s2 =
    iterate1 (fun x s -> (if memb2 x s2 then insrt3 x s else s)) s1 empt3;;

let rec it_union iterate1 insrt2 s1 s2 = iterate1 insrt2 s1 s2;;

let rec iti_ball it s p = it id (fun a _ -> p a) s true;;

let rec rm_empty _A = empty _A;;

let rec emptyc _A = rm_empty linorder_nat;;

let rec hm_empty _A = RBT_HM (emptyc _A);;

let rec s_empty empt = empt;;

let rec hs_empty _A = s_empty (hm_empty _A);;

let rec lh_image_filter (_B1, _B2)
  = it_image_filter ls_iterate (hs_empty _B2) (hs_ins (_B1, _B2));;

let rec brc_iq (_A1, _A2)
  delta =
    lh_image_filter (_A1, _A2)
      (fun r -> (if null (rhsq r) then Some (lhs r) else None)) delta;;

let rec hta_Qi
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_Qi;;

let rec mod_nat m n = snd (Big_int.quomod_big_int m n);;

let fifo_empty : 'a list * 'a list = ([], []);;

let rec s_memb lookup x s = not (is_none (lookup x s));;

let rec hs_memb (_A1, _A2) = s_memb (hm_lookup (_A1, _A2));;

let rec s_iterate iterate f s sigma_0 = iterate (fun k _ -> f k) s sigma_0;;

let rec hs_iterate _A = s_iterate (hm_iterate _A);;

let rec hs_size _A = it_size (hs_iterate _A);;

let rec equal_ta_rulea _A _B
  (Rule (qa, la, listaa)) (Rule (q, l, lista)) =
    eq _A qa q && (eq _B la l && equal_lista _A listaa lista);;

let rec equal_ta_rule _A _B =
  ({equal = equal_ta_rulea _A _B} : ('a, 'b) ta_rule equal);;

let rec ls_ball x = iti_ball ls_iteratei x;;

let rec ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (fun x -> not (memb2 x s2));;

let rec lh_disjoint (_A1, _A2) = ball_disjoint ls_ball (hs_memb (_A1, _A2));;

let rec hta_mema (_A1, _A2) (_B1, _B2)
  t h = not (lh_disjoint (_B1, _B2) (faccs _B1 (_A1, _A2) h t) (hta_Qi h));;

let rec hta_delta
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_delta;;

let rec hta_idx_f_update
  hta_idx_fa
    (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    HashedTa_ext
      (hta_Qi, hta_delta, hta_idx_fa hta_idx_f, hta_idx_s, hta_idx_sf, more);;

let rec idx_build_stepfun
  mlookup mupdate tempty tinsert f x m =
    let i = f x in
    (match mlookup i m with None -> mupdate i (tinsert x tempty) m
      | Some s -> mupdate i (tinsert x s) m);;

let rec idx_build
  mempty mlookup mupdate tempty tinsert siterate f s =
    siterate (idx_build_stepfun mlookup mupdate tempty tinsert f) s mempty;;

let rec hll_idx_build _A (_B1, _B2)
  = idx_build (hm_empty _B2) (hm_lookup (_B1, _B2)) (hm_update (_B1, _B2))
      ls_empty (ls_ins _A) ls_iterate;;

let rec build_rule_index _A _B (_C1, _C2)
  = hll_idx_build (equal_ta_rule _A _B) (_C1, _C2);;

let rec build_rule_index_f _A (_B1, _B2)
  delta = build_rule_index _A _B1 (_B1, _B2) rhsl delta;;

let rec hta_ensure_idx_f _A (_B1, _B2)
  h = (match hta_idx_f h
        with None ->
          hta_idx_f_update
            (fun _ -> Some (build_rule_index_f _A (_B1, _B2) (hta_delta h))) h
        | Some _ -> h);;

let rec hta_mem (_A1, _A2) (_B1, _B2)
  t h = hta_mema (_A1, _A2) (_B1, _B2) t (hta_ensure_idx_f _B1 (_A1, _A2) h);;

let rec pa_cond _A _B _C s = let (_, (w, _)) = s in
                             not (null w);;

let rec hashcode_prod _A _B
  x = Big_int.add_big_int
        (Big_int.mult_big_int (hashcode _A (fst x)) (Big_int.big_int_of_int 33))
        (hashcode _B (snd x));;

let rec bounded_hashcode_prod _A _B
  n x = mod_nat
          (Big_int.add_big_int
            (Big_int.mult_big_int (bounded_hashcode _A n (fst x))
              (Big_int.big_int_of_int 33))
            (bounded_hashcode _B n (snd x)))
          n;;

let rec def_hashmap_size_prod _A _B
  = (fun _ ->
      Big_int.add_big_int (def_hashmap_size _A Type)
        (def_hashmap_size _B Type));;

let rec hashable_prod _A _B =
  ({hashcode = hashcode_prod _A _B;
     bounded_hashcode = bounded_hashcode_prod _A _B;
     def_hashmap_size = def_hashmap_size_prod _A _B}
    : ('a * 'b) hashable);;

let rec equal_proda _A _B (aa, ba) (a, b) = eq _A aa a && eq _B ba b;;

let rec equal_prod _A _B = ({equal = equal_proda _A _B} : ('a * 'b) equal);;

let rec pa_upd_rule (_A1, _A2) (_B1, _B2)
  q w x2 = match q, w, x2 with q, w, [] -> (q, w)
    | q, w, qp :: qs ->
        (if not (hs_memb ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)) qp q)
          then pa_upd_rule (_A1, _A2) (_B1, _B2)
                 (hs_ins ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)) qp q)
                 (qp :: w) qs
          else pa_upd_rule (_A1, _A2) (_B1, _B2) q w qs);;

let rec hta_idx_s
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_idx_s;;

let rec hta_lookup_s (_A1, _A2)
  q h = hl_idx_lookup (_A1, _A2) q (the (hta_idx_s h));;

let rec ls_ins_dj _A = insertb _A;;

let rec hta_idx_sf
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_idx_sf;;

let rec hta_lookup_sf (_A1, _A2) (_B1, _B2)
  q f h =
    hl_idx_lookup ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)) (q, f)
      (the (hta_idx_sf h));;

let rec pa_step (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 s =
    let (q, (w, delta_d)) = s in
    let (q1, q2) = hd w in
    ls_iterate
      (fun r1 ->
        ls_iterate
          (fun r2 res ->
            (if Big_int.eq_big_int (size_list (rhsq r1)) (size_list (rhsq r2))
              then let rp = r_prod r1 r2 in
                   let (qa, (wa, delta_da)) = res in
                   let (qb, wb) =
                     pa_upd_rule (_A1, _A2) (_C1, _C2) qa wa (rhsq rp) in
                   (qb, (wb, ls_ins_dj (equal_ta_rule (equal_prod _A1 _C1) _B1)
                               rp delta_da))
              else res))
          (hta_lookup_sf (_C1, _C2) (_B1, _B2) q2 (rhsl r1) h2))
      (hta_lookup_s (_A1, _A2) q1 h1) (q, (tl w, delta_d));;

let rec map_to_nat
  iterate1 empty2 update2 s =
    snd (iterate1
           (fun x (c, m) ->
             (Big_int.add_big_int c (Big_int.big_int_of_int 1), update2 x c m))
           s
          ((Big_int.big_int_of_int 0), empty2));;

let rec equal_dlista _A
  dxs dys = equal_lista _A (list_of_dlist dxs) (list_of_dlist dys);;

let rec equal_dlist _A = ({equal = equal_dlista _A} : 'a dlist equal);;

let rec iflt_image iflt f s = iflt (fun x -> Some (f x)) s;;

let rec hs_image_filter _A (_B1, _B2)
  = it_image_filter (hs_iterate _A) (hs_empty _B2) (hs_ins (_B1, _B2));;

let rec hs_image _A (_B1, _B2) = iflt_image (hs_image_filter _A (_B1, _B2));;

let rec s_ins_dj update_dj x s = update_dj x () s;;

let rec hm_update_dj (_A1, _A2) = hm_update (_A1, _A2);;

let rec hs_ins_dj (_A1, _A2) = s_ins_dj (hm_update_dj (_A1, _A2));;

let rec hs_inter (_A1, _A2)
  = it_inter (hs_iterate _A2) (hs_memb (_A1, _A2)) (hs_empty _A2)
      (hs_ins_dj (_A1, _A2));;

let rec s_union add = add;;

let rec hs_union (_A1, _A2) = s_union (hm_add (_A1, _A2));;

let rec hhh_cart (_A1, _A2) (_B1, _B2)
  = cart (hs_iterate _A2) (hs_iterate _B2) (hs_empty (hashable_prod _A2 _B2))
      (hs_ins_dj ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)));;

let rec brc_cond _A _B = (fun (_, (w, _)) -> not (null w));;

let rec rqrm_lookup (_A1, _A2)
  rqrm q =
    (match hm_lookup (_A1, _A2) q rqrm with None -> ls_empty | Some s -> s);;

let rec hashcode_list _A
  = foldl (fun h x ->
            Big_int.add_big_int
              (Big_int.mult_big_int h (Big_int.big_int_of_int 33))
              (hashcode _A x))
      (Big_int.big_int_of_int 5381);;

let rec hashcode_of_ta_rule _A _B
  (Rule (q, f, qs)) =
    Big_int.add_big_int (Big_int.add_big_int (hashcode _A q) (hashcode _B f))
      (hashcode_list _A qs);;

let rec hashcode_ta_rule _A _B = hashcode_of_ta_rule _A _B;;

let rec bounded_hashcode_ta_rule _A _B
  n r = mod_nat (hashcode_of_ta_rule _A _B r) n;;

let rec def_hashmap_size_ta_rule _A _B
  = (fun _ -> (Big_int.big_int_of_int 32));;

let rec hashable_ta_rule _A _B =
  ({hashcode = hashcode_ta_rule _A _B;
     bounded_hashcode = bounded_hashcode_ta_rule _A _B;
     def_hashmap_size = def_hashmap_size_ta_rule _A _B}
    : ('a, 'b) ta_rule hashable);;

let rec brc_inner_step (_A1, _A2) (_B1, _B2)
  r = (fun (q, (w, rcm)) ->
        let c =
          the (hm_lookup ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
                rcm)
          in
        let rcma =
          hm_update ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
            (minus_nat c (Big_int.big_int_of_int 1)) rcm
          in
        let qa =
          (if Big_int.le_big_int c (Big_int.big_int_of_int 1)
            then hs_ins (_A1, _A2) (lhs r) q else q)
          in
        let wa =
          (if Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
                not (hs_memb (_A1, _A2) (lhs r) q)
            then lhs r :: w else w)
          in
        (qa, (wa, rcma)));;

let rec brc_step (_A1, _A2) (_B1, _B2)
  rqrm =
    (fun (q, (w, rcm)) ->
      ls_iterate (brc_inner_step (_A1, _A2) (_B1, _B2))
        (rqrm_lookup (_A1, _A2) rqrm (hd w)) (q, (tl w, rcm)));;

let rec brec_iqm (_A1, _A2) _B
  delta =
    ls_iterate
      (fun r m ->
        (if null (rhsq r)
          then hm_update (_A1, _A2) (lhs r) (Node (rhsl r, [])) m else m))
      delta (hm_empty _A2);;

let rec init_hta qi delta = HashedTa_ext (qi, delta, None, None, None, ());;

let rec it_set_to_list iterate s = iterate (fun a b -> a :: b) s [];;

let rec hs_to_list _A = it_set_to_list (hs_iterate _A);;

let rec pa_initial (_A1, _A2) _B (_C1, _C2)
  h1 h2 =
    let qip = hhh_cart (_A1, _A2) (_C1, _C2) (hta_Qi h1) (hta_Qi h2) in
    (qip, (hs_to_list (hashable_prod _A2 _C2) qip, ls_empty));;

let rec while_option b c s = (if b s then while_option b c (c s) else Some s);;

let rec whilea b c s = the (while_option b c s);;

let rec hta_proda (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    let (_, (_, a)) =
      whilea (pa_cond _A2 _C2 _B2)
        (pa_step (_A1, _A2) (_B1, _B2) (_C1, _C2) h1 h2)
        (pa_initial (_A1, _A2) _B2 (_C1, _C2) h1 h2)
      in
    init_hta (hhh_cart (_A1, _A2) (_C1, _C2) (hta_Qi h1) (hta_Qi h2)) a;;

let rec hta_idx_s_update
  hta_idx_sa
    (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    HashedTa_ext
      (hta_Qi, hta_delta, hta_idx_f, hta_idx_sa hta_idx_s, hta_idx_sf, more);;

let rec build_rule_index_s (_A1, _A2) _B
  delta = build_rule_index _A1 _B (_A1, _A2) lhs delta;;

let rec hta_ensure_idx_s (_A1, _A2) _B
  h = (match hta_idx_s h
        with None ->
          hta_idx_s_update
            (fun _ -> Some (build_rule_index_s (_A1, _A2) _B (hta_delta h))) h
        | Some _ -> h);;

let rec hta_idx_sf_update
  hta_idx_sfa
    (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    HashedTa_ext
      (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sfa hta_idx_sf, more);;

let rec build_rule_index_sf (_A1, _A2) (_B1, _B2)
  delta =
    build_rule_index _A1 _B1 ((equal_prod _A1 _B1), (hashable_prod _A2 _B2))
      (fun r -> (lhs r, rhsl r)) delta;;

let rec hta_ensure_idx_sf (_A1, _A2) (_B1, _B2)
  h = (match hta_idx_sf h
        with None ->
          hta_idx_sf_update
            (fun _ ->
              Some (build_rule_index_sf (_A1, _A2) (_B1, _B2) (hta_delta h)))
            h
        | Some _ -> h);;

let rec hta_prod (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    hta_proda (_A1, _A2) (_B1, _B2) (_C1, _C2)
      (hta_ensure_idx_s (_A1, _A2) _B1 h1)
      (hta_ensure_idx_sf (_C1, _C2) (_B1, _B2) h2);;

let rec hashcode_nat n = n;;

let rec bounded_hashcode_nat na n = mod_nat n na;;

let rec def_hashmap_size_nat x = (fun _ -> (Big_int.big_int_of_int 16)) x;;

let hashable_nat =
  ({hashcode = hashcode_nat; bounded_hashcode = bounded_hashcode_nat;
     def_hashmap_size = def_hashmap_size_nat}
    : Big_int.big_int hashable);;

let rec htai_mem
  x = hta_mem (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec rqrm_add (_A1, _A2) _B
  q r res =
    (match hm_lookup (_A1, _A2) q res
      with None -> hm_update (_A1, _A2) q (ls_ins _B r ls_empty) res
      | Some s -> hm_update (_A1, _A2) q (ls_ins _B r s) res);;

let rec fifo_dequeue
  f = (match snd f with [] -> let rp = rev (fst f) in
                              (hd rp, ([], tl rp))
        | a :: l -> (a, (fst f, l)));;

let rec fifo_enqueue a f = (a :: fst f, snd f);;

let rec fifo_isEmpty _A
  f = equal_proda (equal_list _A) (equal_list _A) f ([], []);;

let rec lhh_union (_A1, _A2) = it_union ls_iterate (hs_ins (_A1, _A2));;

let rec brec_cond _A
  = (fun (_, (w, (_, qwit))) -> not (fifo_isEmpty _A w) && is_none qwit);;

let rec brec_construct_witness (_A1, _A2) _B
  qm r =
    Node (rhsl r, map (fun q -> the (hm_lookup (_A1, _A2) q qm)) (rhsq r));;

let rec brec_inner_step (_A1, _A2) (_B1, _B2)
  qi r =
    (fun (q, (w, (rcm, qwit))) ->
      let c =
        the (hm_lookup ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
              rcm)
        in
      let cond =
        Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
          is_none (hm_lookup (_A1, _A2) (lhs r) q)
        in
      let rcma =
        hm_update ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
          (minus_nat c (Big_int.big_int_of_int 1)) rcm
        in
      let qa =
        (if cond
          then hm_update (_A1, _A2) (lhs r)
                 (brec_construct_witness (_A1, _A2) _B2 q r) q
          else q)
        in
      let wa = (if cond then fifo_enqueue (lhs r) w else w) in
      let qwita =
        (if Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
              hs_memb (_A1, _A2) (lhs r) qi
          then Some (lhs r) else qwit)
        in
      (qa, (wa, (rcma, qwita))));;

let rec brec_step (_A1, _A2) (_B1, _B2)
  rqrm qi =
    (fun (q, (w, (rcm, qwit))) ->
      let (qa, wa) = fifo_dequeue w in
      ls_iterate (brec_inner_step (_A1, _A2) (_B1, _B2) qi)
        (rqrm_lookup (_A1, _A2) rqrm qa) (q, (wa, (rcm, qwit))));;

let rec hta_empty _A _B = init_hta (hs_empty _A) ls_empty;;

let rec ls_image _B = iflt_image (ls_image_filter _B);;

let rec hta_remap _A (_B1, _B2) (_C1, _C2)
  f h = init_hta (hs_image _A (_B1, _B2) f (hta_Qi h))
          (ls_image (equal_ta_rule _B1 _C1) (remap_rule f) (hta_delta h));;

let rec equal_ustate_wrappera _A _B
  x0 x1 = match x0, x1 with USW2 q2, USW1 q1 -> false
    | USW1 q1, USW2 q2 -> false
    | USW2 q2a, USW2 q2 -> eq _B q2a q2
    | USW1 q1a, USW1 q1 -> eq _A q1a q1;;

let rec equal_ustate_wrapper _A _B =
  ({equal = equal_ustate_wrappera _A _B} : ('a, 'b) ustate_wrapper equal);;

let rec ls_union _A = it_union ls_iterate (ls_ins _A);;

let rec ls_union_dj _A = ls_union _A;;

let rec hashcode_ustate_wrapper _A _B
  x = (match x
        with USW1 a ->
          Big_int.mult_big_int (Big_int.big_int_of_int 2) (hashcode _A a)
        | USW2 b ->
          Big_int.add_big_int
            (Big_int.mult_big_int (Big_int.big_int_of_int 2) (hashcode _B b))
            (Big_int.big_int_of_int 1));;

let rec bounded_hashcode_ustate_wrapper _A _B
  n x = (match x with USW1 a -> bounded_hashcode _A n a
          | USW2 b ->
            minus_nat (minus_nat n (Big_int.big_int_of_int 1))
              (bounded_hashcode _B n b));;

let rec def_hashmap_size_ustate_wrapper _A _B
  = (fun _ ->
      Big_int.add_big_int (def_hashmap_size _A Type)
        (def_hashmap_size _B Type));;

let rec hashable_ustate_wrapper _A _B =
  ({hashcode = hashcode_ustate_wrapper _A _B;
     bounded_hashcode = bounded_hashcode_ustate_wrapper _A _B;
     def_hashmap_size = def_hashmap_size_ustate_wrapper _A _B}
    : ('a, 'b) ustate_wrapper hashable);;

let rec hta_union (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    init_hta
      (hs_union
        ((equal_ustate_wrapper _A1 _C1), (hashable_ustate_wrapper _A2 _C2))
        (hs_image _A2
          ((equal_ustate_wrapper _A1 _C1), (hashable_ustate_wrapper _A2 _C2))
          (fun a -> USW1 a) (hta_Qi h1))
        (hs_image _C2
          ((equal_ustate_wrapper _A1 _C1), (hashable_ustate_wrapper _A2 _C2))
          (fun a -> USW2 a) (hta_Qi h2)))
      (ls_union_dj (equal_ta_rule (equal_ustate_wrapper _A1 _C1) _B1)
        (ls_image (equal_ta_rule (equal_ustate_wrapper _A1 _C1) _B1)
          (remap_rule (fun a -> USW1 a)) (hta_delta h1))
        (ls_image (equal_ta_rule (equal_ustate_wrapper _A1 _C1) _B1)
          (remap_rule (fun a -> USW2 a)) (hta_delta h2)));;

let rec list_to_ls _A xs = Dlist (remdups _A xs);;

let rec rule_states_l _A (Rule (q, f, qs)) = ls_ins _A q (list_to_ls _A qs);;

let rec it_Union_image it1 em3 un233 f s = it1 (fun x -> un233 (f x)) s em3;;

let rec llh_Union_image (_B1, _B2)
  = it_Union_image ls_iterate (hs_empty _B2) (lhh_union (_B1, _B2));;

let rec hta_delta_states (_A1, _A2)
  h = llh_Union_image (_A1, _A2) id
        (ls_image_filter (equal_dlist _A1) (fun r -> Some (rule_states_l _A1 r))
          (hta_delta h));;

let rec hta_states (_A1, _A2)
  h = hs_union (_A1, _A2) (hta_Qi h) (hta_delta_states (_A1, _A2) h);;

let rec hh_map_to_nat (_A1, _A2)
  = map_to_nat (hs_iterate _A2) (hm_empty _A2) (hm_update (_A1, _A2));;

let rec hta_reindex (_A1, _A2) (_B1, _B2)
  h = let mp = hh_map_to_nat (_A1, _A2) (hta_states (_A1, _A2) h) in
      hta_remap _A2 (equal_nat, hashable_nat) (_B1, _B2)
        (fun q -> the (hm_lookup (_A1, _A2) q mp)) h;;

let rec htai_prod
  h1 h2 =
    hta_reindex
      ((equal_prod equal_nat equal_nat),
        (hashable_prod hashable_nat hashable_nat))
      (equal_nat, hashable_nat)
      (hta_prod (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        (equal_nat, hashable_nat) h1 h2);;

let rec rs_iterate _A = s_iterate (rm_iterate _A);;

let rec rs_size _A = it_size (rs_iterate _A);;

let rec it_set_to_List_enq iterate emp enq s = iterate enq s emp;;

let rec it_set_to_fifo it = it_set_to_List_enq it fifo_empty fifo_enqueue;;

let rec hs_to_fifo _A = it_set_to_fifo (hs_iterate _A);;

let rec build_rqrm (_A1, _A2) (_B1, _B2)
  delta =
    ls_iterate
      (fun r res ->
        foldl (fun resa q ->
                rqrm_add (_A1, _A2) (equal_ta_rule _A1 _B1) q r resa)
          res (rhsq r))
      delta (hm_empty _A2);;

let rec hta_add_qi (_A1, _A2) _B
  qi h = init_hta (hs_ins (_A1, _A2) qi (hta_Qi h)) (hta_delta h);;

let rec lll_inj_image_filter_cp _C
  = inj_image_filter_cp ls_iterate ls_iterate ls_empty (ls_ins_dj _C);;

let rec delta_prod_h (_A1, _A2) (_B1, _B2) (_C1, _C2)
  delta_1 delta_2 =
    lll_inj_image_filter_cp (equal_ta_rule (equal_prod _A1 _C1) _B1) r_prod
      (fun r1 r2 ->
        eq _B1 (rhsl r1) (rhsl r2) &&
          Big_int.eq_big_int (size_list (rhsq r1)) (size_list (rhsq r2)))
      delta_1 delta_2;;

let rec hta_prodWR (_A1, _A2) (_B1, _B2) (_D1, _D2)
  h1 h2 =
    init_hta (hhh_cart (_A1, _A2) (_D1, _D2) (hta_Qi h1) (hta_Qi h2))
      (delta_prod_h (_A1, _A2) (_B1, _B2) (_D1, _D2) (hta_delta h1)
        (hta_delta h2));;

let rec hta_reduce (_A1, _A2) _B
  h q = init_hta (hs_inter (_A1, _A2) q (hta_Qi h))
          (ls_image_filter (equal_ta_rule _A1 _B)
            (fun r ->
              (if hs_memb (_A1, _A2) (lhs r) q &&
                    list_all (fun qa -> hs_memb (_A1, _A2) qa q) (rhsq r)
                then Some r else None))
            (hta_delta h));;

let htai_empty : (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext
  = hta_empty hashable_nat hashable_nat;;

let rec htai_union
  h1 h2 =
    hta_reindex
      ((equal_ustate_wrapper equal_nat equal_nat),
        (hashable_ustate_wrapper hashable_nat hashable_nat))
      (equal_nat, hashable_nat)
      (hta_union (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        (equal_nat, hashable_nat) h1 h2);;

let rec ls_size x = it_size ls_iterate x;;

let rec brc_rcm_init (_A1, _A2) (_B1, _B2)
  delta =
    ls_iterate
      (fun r ->
        hm_update ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
          (size_list (remdups _A1 (rhsq r))))
      delta (hm_empty (hashable_ta_rule _A2 _B2));;

let rec brc_initial (_A1, _A2) (_B1, _B2)
  delta =
    let iq = brc_iq (_A1, _A2) delta in
    (iq, (hs_to_list _A2 iq, brc_rcm_init (_A1, _A2) (_B1, _B2) delta));;

let rec htai_add_qi x = hta_add_qi (equal_nat, hashable_nat) hashable_nat x;;

let rec htai_prodWR
  h1 h2 =
    hta_reindex
      ((equal_prod equal_nat equal_nat),
        (hashable_prod hashable_nat hashable_nat))
      (equal_nat, hashable_nat)
      (hta_prodWR (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        (equal_nat, hashable_nat) h1 h2);;

let rec sel_disjoint_witness
  sel1 mem2 s1 s2 = sel1 s1 (fun x -> (if mem2 x s2 then Some x else None));;

let rec hh_disjoint_witness (_A1, _A2)
  = sel_disjoint_witness (hs_sel _A2) (hs_memb (_A1, _A2));;

let rec brec_initial (_A1, _A2) (_B1, _B2)
  qi delta =
    let iq = brc_iq (_A1, _A2) delta in
    (brec_iqm (_A1, _A2) _B2 delta,
      (hs_to_fifo _A2 iq,
        (brc_rcm_init (_A1, _A2) (_B1, _B2) delta,
          hh_disjoint_witness (_A1, _A2) iq qi)));;

let rec hta_add_rule (_A1, _A2) (_B1, _B2)
  r h = init_hta (hta_Qi h) (ls_ins (equal_ta_rule _A1 _B1) r (hta_delta h));;

let rec htai_add_rule
  x = hta_add_rule (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec hta_bwd_reduce (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      hta_reduce (_A1, _A2) _B1 h
        (fst (whilea (brc_cond _A2 _B2) (brc_step (_A1, _A2) (_B1, _B2) rqrm)
               (brc_initial (_A1, _A2) (_B1, _B2) (hta_delta h))));;

let rec htai_bwd_reduce
  x = hta_bwd_reduce (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec htai_ensure_idx_f
  x = hta_ensure_idx_f equal_nat (equal_nat, hashable_nat) x;;

let rec htai_ensure_idx_s
  x = hta_ensure_idx_s (equal_nat, hashable_nat) equal_nat x;;

let rec htai_ensure_idx_sf
  x = hta_ensure_idx_sf (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec hta_is_empty_witness (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      (match
        whilea (brec_cond _A1) (brec_step (_A1, _A2) (_B1, _B2) rqrm (hta_Qi h))
          (brec_initial (_A1, _A2) (_B1, _B2) (hta_Qi h) (hta_delta h))
        with (q, (_, (_, None))) -> None
        | (q, (_, (_, Some qa))) -> hm_lookup (_A1, _A2) qa q);;

let rec htai_is_empty_witness
  x = hta_is_empty_witness (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        x;;

end;; (*struct Ta*)
